package esp.home.wsarena.testclient;

import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.ws.Service;

import org.testng.Assert;
import org.testng.annotations.Test;

import esp.home.wsarena.client.FooService;
import esp.home.wsarena.client.FooServiceService;

/**
 * Main client test class. Integration testing. SUN Metro WS implementation.
 * 
 * It requires to all tested web services be successfully deployed and running on server on localhost!
 * 
 * Namespace URI "http://service.wsarena.home.esp/" was autogenerated! From service POJO classpath. 
 * It should be redefined by some anotation to less Javvy.
 * 
 * @author espinosa, 31.12.2009, 1.1.2010
 */
@Test
public class ClientTest2 {
	
	private static final String serviceURL = "http://localhost:8080/wsarena3-metro/FooService";


	/**
	 * Approach using generated FooServiceService client stub.
	 * @throws Exception
	 */
	@Test
	public void test1() throws Exception {
		FooServiceService serviceProxyFactory = new FooServiceService(
				new URL(serviceURL + "?wsdl"),
				new QName("http://service.wsarena.home.esp/", "FooServiceService"));
		FooService fooService = serviceProxyFactory.getFooServicePort();
		fooService.fooMethod1("test1 A");

		String result1 = fooService.fooMethod2("test1 B");
		Assert.assertEquals(result1, "OK");
	}

	/**
	 * Different approach using javax.xml.ws.Service (from JBossWS help).
	 * http://community.jboss.org/wiki/JBossWS-MetroWS-ReliableMessagingTutorial
	 */
	@Test
	public void test2() throws Exception {
		QName serviceName = new QName("http://service.wsarena.home.esp/", "FooServiceService");
		URL wsdlURL = new URL(serviceURL + "?wsdl");
		Service service = Service.create(wsdlURL, serviceName);
		FooService proxy = (FooService)service.getPort(FooService.class);
		
		// one way call
		proxy.fooMethod1("test1 A");

		// request responce call
		String result1 = proxy.fooMethod2("test1 B");
		Assert.assertEquals(result1, "OK");
	}
}
